#### library ####

import json, urllib, urllib2

def encode2(call2): return urllib.quote_plus(json.dumps(call2))
urls = ["https://a.totp.me:8443/prot",
        "https://b1.totp.me:18443/prot2",
        "https://b2.totp.me:28443/prot2",
        "https://b3.totp.me:38443/prot2",
        "https://b4.totp.me:48443/prot2"]
def fetch(urls, action, key, arg):
  if len(urls) == 0: raise Exception("could not connect to any servers")
  try:
    return urllib2.urlopen(urllib2.Request(
             urls[0]+"?action="+action+"&key="+key+"&arg="+arg)).read()
  except Exception:
    return fetch(urls[1:], action, key, arg)
def make_client_msg(key, call2):
  global urls
  return fetch(urls, "make-client-msg", key, encode2(call2))
def decode_server_msg(key, msg, sid):
  global urls
  sid2 = int(sid) if sid else 0
  return json.loads(fetch(urls[sid2:sid2+1], "decode-server-msg", key, msg))

####
REQS="totp:outstanding-reqs"

#sessions are stored in DB
#can't serialize oreq handler functions
#so let's store oreqs in a global table in memory
#TODO: ids *have* to be unique now
#      you must expire old entries
#also only single server python webapps can use this
reqfns={}
def push_outstanding_request_obs(session, oreq):
  x = session.get(REQS)
  if x == None:
    x = []
    session[REQS] = x
  x.insert(0, oreq)
  return x;
def push_outstanding_request(session, oreq):
  global reqfns
  reqfns[oreq[0]] = oreq
def identity(x): return x
def car(xs): return xs[0]
def pop_first (x, xs, key=identity):
  for x1 in xs:
    if key(x1) == x:
      xs.remove(x1)
      return x1
def remove_outstanding_request_obs(session, reqid):
  return pop_first(reqid, session.get(REQS), key=car)
def remove_outstanding_request(session, reqid):
  global reqfns
  ans=reqfns[reqid]
  del reqfns[reqid]
  return ans
next_id=0
#todo atomically
def next_req_id():
  global next_id
  next_id = next_id + 1
  return next_id
key=None
def call1(session, fn, u, h):
  global key
  reqid = next_req_id()
  oreq = [reqid, u, h]
  push_outstanding_request(session, oreq)
  return make_client_msg(key, [reqid, fn, u])
def prov(s, u, h):
  return call1(s, "prov", u, h)
def auth(s, u, h):
  return call1(s, "auth", u, h)

####
def otp_response(request):
  global key
  res2 = decode_server_msg(key, request.GET["res"], request.GET.get("sid"))
  oreq = remove_outstanding_request(request.session, res2[0])
  return oreq[2](request, oreq[1], res2[1] != [])

